diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/NBTFormatHelper.java b/game/core/src/main/java/net/minecraft/core/util/helper/NBTFormatHelper.java
new file mode 100644
index 000000000..ba891371a
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/NBTFormatHelper.java
@@ -0,0 +1,402 @@
+package net.minecraft.core.util.helper;
+
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.net.command.TextFormatting;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Arrays;
+import java.util.regex.Matcher;
+import java.util.regex.Pattern;
+
+public class NBTFormatHelper {
+
+    //removes version and expanded tags, modifies id, damage, and tile entity data
+    private static final Pattern VERSION_PATTERN = Pattern.compile("\"?(Version)\"?\\s*:\\s*([^,;{}]+|\"[^\"]*\")\\s*[;,]?\\s*");
+    private static final Pattern EXPANDED_PATTERN = Pattern.compile("\"?(Expanded)\"?\\s*:\\s*([^,;{}]+|\"[^\"]*\")\\s*[;,]?\\s*");
+    private static final Pattern ID_PATTERN = Pattern.compile("\"?id\"?\\s*:\\s*(-?\\d+)");
+    private static final Pattern DAMAGE_PATTERN = Pattern.compile("\"?Damage\"?\\s*:\\s*(-?\\d+)");
+    private static final Pattern TILE_ENTITY_DATA_PATTERN = Pattern.compile("\"?tileEntityData\"?\\s*:\\s*(?=\\{)");
+
+    //key patterns to match/look for
+    private static final Pattern EMPTY_KEY_PATTERN = Pattern.compile("\"\"\\s*:\\s*");
+    private static final Pattern QUOTED_KEY_PATTERN = Pattern.compile("\"([^\"]+)\"\\s*:");
+
+    //formatNBTTooltip strips out a lot of whitespace, this char is used to replace it if it needs to be preserved
+    private static final char VISIBLE_SPACE = '\u00A0';
+
+    public static @NotNull String formatNbtTooltip(String nbtString) {
+        nbtString = VERSION_PATTERN.matcher(nbtString).replaceAll("");
+        nbtString = EXPANDED_PATTERN.matcher(nbtString).replaceAll("");
+        nbtString = processTopLevelTileEntityData(nbtString);
+        nbtString = resolveEmptyKeys(nbtString);
+        nbtString = QUOTED_KEY_PATTERN.matcher(nbtString).replaceAll("$1:");
+
+        boolean[] inlineMask = getInlineMask(nbtString);
+        StringBuilder stringBuilder = new StringBuilder(nbtString.length() * 2);
+
+        int indentLevel = 0;
+        boolean inQuotes = false;
+        boolean isKey = true;
+        boolean colorNeedsUpdate = true;
+        boolean[] inObjectStack = new boolean[128];
+
+        TextFormatting syntaxColor = TextFormatting.GRAY;
+        TextFormatting contentColor = TextFormatting.LIGHT_GRAY;
+        TextFormatting titleColor = TextFormatting.MAGENTA;
+
+        for (int i = 0; i < nbtString.length(); i++) {
+            char charAt = nbtString.charAt(i);
+            boolean inline = inlineMask[i];
+
+            if (charAt == '"') {
+                if (!inQuotes) {
+                    stringBuilder.append(contentColor).append(charAt);
+                    inQuotes = true;
+                } else {
+                    stringBuilder.append(charAt);
+                    inQuotes = false;
+                    colorNeedsUpdate = true;
+                }
+                continue;
+            }
+
+            if (inQuotes) {
+                stringBuilder.append(charAt);
+                continue;
+            }
+
+            if (charAt == ' ' || charAt == '\n' || charAt == '\r' || charAt == '\t') continue;
+
+            if (charAt == '{' || charAt == '[' || charAt == '(') {
+                indentLevel++;
+                if (indentLevel >= inObjectStack.length) {
+                    inObjectStack = Arrays.copyOf(inObjectStack, inObjectStack.length * 2);
+                }
+
+                boolean isObj = (charAt == '{' || charAt == '(');
+                inObjectStack[indentLevel] = isObj;
+                isKey = isObj;
+
+                stringBuilder.append(syntaxColor).append(charAt);
+                colorNeedsUpdate = true;
+
+                char nextChar = nextNonWhitespace(nbtString, i + 1);
+                if (isMatchingClose(charAt, nextChar)) {
+                    stringBuilder.append(nextChar);
+                    while (i + 1 < nbtString.length() && Character.isWhitespace(nbtString.charAt(i + 1))) i++;
+                    i++;
+                    indentLevel--;
+                } else {
+                    stringBuilder.append(inline ? " " : "\n" + getIndent(indentLevel));
+                }
+            } else if (charAt == '}' || charAt == ']' || charAt == ')') {
+                indentLevel = Math.max(0, indentLevel - 1);
+                stringBuilder.append(inline ? " " : "\n" + getIndent(indentLevel));
+                stringBuilder.append(syntaxColor).append(charAt);
+                colorNeedsUpdate = true;
+            } else if (charAt == ',' || charAt == ';') {
+                stringBuilder.append(syntaxColor).append(charAt);
+                colorNeedsUpdate = true;
+                isKey = indentLevel > 0 && inObjectStack[indentLevel];
+
+                char nextChar = nextNonWhitespace(nbtString, i + 1);
+                if (nextChar != '}' && nextChar != ']' && nextChar != ')') {
+                    if (!inline) {
+                        stringBuilder.append('\n').append(getIndent(indentLevel));
+                    } else {
+                        stringBuilder.append(' ');
+                    }
+                }
+            } else if (charAt == ':') {
+                stringBuilder.append(syntaxColor).append(": ");
+                colorNeedsUpdate = true;
+                isKey = false;
+            } else {
+                if (colorNeedsUpdate) {
+                    stringBuilder.append(isKey ? titleColor : contentColor);
+                    colorNeedsUpdate = false;
+                }
+                stringBuilder.append(charAt);
+            }
+        }
+
+        return stringBuilder.toString();
+    }
+
+    private static @NotNull String resolveEmptyKeys(@NotNull String nbt) {
+        Matcher keyMatcher = EMPTY_KEY_PATTERN.matcher(nbt);
+        StringBuilder result = new StringBuilder(nbt.length());
+        int lastEnd = 0;
+
+        while (keyMatcher.find()) {
+            int matchStart = keyMatcher.start();
+            int matchEnd = keyMatcher.end();
+            result.append(nbt, lastEnd, matchStart);
+
+            int openBrace = nbt.indexOf('{', matchEnd);
+
+            if (openBrace != -1 && isOnlyWhitespace(nbt, matchEnd, openBrace)) {
+                int closeBrace = findMatchingBrace(nbt, openBrace);
+                if (closeBrace != -1) {
+                    CharSequence block = nbt.subSequence(openBrace, closeBrace + 1);
+                    Matcher idMatcher = ID_PATTERN.matcher(block);
+
+                    if (idMatcher.find()) {
+                        try {
+                            int id = Integer.parseInt(idMatcher.group(1));
+                            int damage = 0;
+                            Matcher dmgMatcher = DAMAGE_PATTERN.matcher(block);
+                            if (dmgMatcher.find()) {
+                                damage = Integer.parseInt(dmgMatcher.group(1));
+                            }
+
+                            String itemKey = "Item" + VISIBLE_SPACE + VISIBLE_SPACE + id;
+                            try {
+                                ItemStack stack = new ItemStack(id, 1, damage);
+                                itemKey = stack.getItemKey();
+                            } catch (Exception ignored) {}
+
+                            result.append(itemKey).append(":");
+                            lastEnd = matchEnd;
+                            continue;
+                        } catch (NumberFormatException ignored) {}
+                    }
+                }
+            }
+
+            result.append("Tag:");
+            lastEnd = matchEnd;
+        }
+
+        result.append(nbt, lastEnd, nbt.length());
+        return result.toString();
+    }
+
+    private static @NotNull String processTopLevelTileEntityData(@NotNull String nbt) {
+        Matcher matcher = TILE_ENTITY_DATA_PATTERN.matcher(nbt);
+        StringBuilder result = new StringBuilder(nbt.length());
+        int searchStart = 0;
+
+        while (matcher.find(searchStart)) {
+            int openBrace = matcher.end();
+            int closeBrace = findMatchingBrace(nbt, openBrace);
+
+            if (closeBrace != -1) {
+                result.append(nbt, searchStart, openBrace + 1);
+
+                String inner = nbt.substring(openBrace + 1, closeBrace);
+                result.append(collapseAllTileEntityData(inner));
+
+                searchStart = closeBrace;
+            } else {
+                result.append(nbt, searchStart, openBrace);
+                searchStart = openBrace;
+            }
+        }
+
+        result.append(nbt, searchStart, nbt.length());
+        return result.toString();
+    }
+
+    private static @NotNull String collapseAllTileEntityData(@NotNull String nbt) {
+        Matcher matcher = TILE_ENTITY_DATA_PATTERN.matcher(nbt);
+        StringBuilder result = new StringBuilder(nbt.length());
+        int searchStart = 0;
+
+        while (matcher.find(searchStart)) {
+            int openBrace = matcher.end();
+            int closeBrace = findMatchingBrace(nbt, openBrace);
+
+            if (closeBrace != -1) {
+                int tags = countTags(nbt, openBrace, closeBrace);
+                String tagWord = tags == 1 ? "Tag" : "Tags";
+                String replacement = "<" + tags + VISIBLE_SPACE + tagWord + ">";
+
+                result.append(nbt, searchStart, openBrace);
+                result.append(replacement);
+
+                searchStart = closeBrace + 1;
+            } else {
+                result.append(nbt, searchStart, openBrace);
+                searchStart = openBrace;
+            }
+        }
+
+        result.append(nbt, searchStart, nbt.length());
+        return result.toString();
+    }
+
+    private static boolean @NotNull [] getInlineMask(@NotNull String nbt) {
+        boolean[] mask = new boolean[nbt.length()];
+
+        for (int i = 0; i < nbt.length(); i++) {
+            char charAt = nbt.charAt(i);
+            if (charAt == '{' || charAt == '[') {
+                int closeIndex = findMatchingBrace(nbt, i);
+                if (closeIndex != -1) {
+                    boolean isFlat = true;
+                    boolean inQuotes = false;
+                    boolean escaped = false;
+
+                    for (int j = i + 1; j < closeIndex; j++) {
+                        char inner = nbt.charAt(j);
+                        if (escaped) {
+                            escaped = false;
+                            continue;
+                        }
+                        if (inner == '\\') {
+                            escaped = true;
+                            continue;
+                        }
+                        if (inner == '"') {
+                            inQuotes = !inQuotes;
+                        } else if (!inQuotes) {
+                            if (inner == '{' || inner == '[' || inner == '}' || inner == ']') {
+                                isFlat = false;
+                                break;
+                            }
+                        }
+                    }
+
+                    if (isFlat) {
+                        for (int j = i; j <= closeIndex; j++) {
+                            mask[j] = true;
+                        }
+                    }
+                }
+            }
+        }
+
+        String target = VISIBLE_SPACE + "Tag";
+        int start = 0;
+
+        while (true) {
+            int index = nbt.indexOf(target, start);
+            if (index == -1) break;
+
+            int openBrace = -1;
+            int depth = 0;
+            boolean inQuotes = false;
+            for (int i = index; i >= 0; i--) {
+                char charAt = nbt.charAt(i);
+                if (charAt == '"') inQuotes = !inQuotes;
+                if (!inQuotes) {
+                    if (charAt == '}' || charAt == ']' || charAt == ')') depth++;
+                    else if (charAt == '{' || charAt == '[' || charAt == '(') {
+                        if (depth == 0) {
+                            openBrace = i;
+                            break;
+                        } else {
+                            depth--;
+                        }
+                    }
+                }
+            }
+
+            if (openBrace != -1) {
+                int closeBrace = findMatchingBrace(nbt, openBrace);
+                if (closeBrace != -1) {
+                    for (int i = openBrace; i <= closeBrace; i++) {
+                        mask[i] = true;
+                    }
+                }
+            }
+            start = index + target.length();
+        }
+        return mask;
+    }
+
+    private static int findMatchingBrace(@NotNull String str, int startIndex) {
+        int depth = 0;
+        boolean inQuotes = false;
+        boolean escaped = false;
+
+        for (int i = startIndex; i < str.length(); i++) {
+            char charAt = str.charAt(i);
+
+            if (escaped) {
+                escaped = false;
+                continue;
+            }
+            if (charAt == '\\') {
+                escaped = true;
+                continue;
+            }
+            if (charAt == '"') {
+                inQuotes = !inQuotes;
+            } else if (!inQuotes) {
+                if (charAt == '{') depth++;
+                else if (charAt == '}') {
+                    depth--;
+                    if (depth == 0) return i;
+                }
+            }
+        }
+        return -1;
+    }
+
+    private static int countTags(String nbt, int openBrace, int closeBrace) {
+        int depth = 0;
+        int tags = 0;
+        boolean inQuotes = false;
+        boolean escaped = false;
+        boolean hasContent = false;
+
+        for (int i = openBrace; i <= closeBrace; i++) {
+            char charAt = nbt.charAt(i);
+
+            if (escaped) {
+                escaped = false;
+                continue;
+            }
+            if (charAt == '\\') {
+                escaped = true;
+                continue;
+            }
+            if (charAt == '"') {
+                inQuotes = !inQuotes;
+            } else if (!inQuotes) {
+                if (charAt == '{' || charAt == '[') depth++;
+                else if (charAt == '}' || charAt == ']') {
+                    depth--;
+                    if (depth == 0 && charAt == '}') {
+                        if (hasContent) tags++;
+                        break;
+                    }
+                } else if (charAt == ',' && depth == 1) {
+                    tags++;
+                    hasContent = false;
+                } else if (!Character.isWhitespace(charAt)) {
+                    hasContent = true;
+                }
+            }
+        }
+        return tags;
+    }
+
+    private static boolean isOnlyWhitespace(String str, int start, int end) {
+        for (int i = start; i < end; i++) {
+            if (!Character.isWhitespace(str.charAt(i))) return false;
+        }
+        return true;
+    }
+
+    private static char nextNonWhitespace(@NotNull String str, int startIndex) {
+        for (int i = startIndex; i < str.length(); i++) {
+            char charAt = str.charAt(i);
+            if (!Character.isWhitespace(charAt)) return charAt;
+        }
+        return '\0';
+    }
+
+    private static boolean isMatchingClose(char open, char close) {
+        return (open == '{' && close == '}') ||
+                (open == '[' && close == ']') ||
+                (open == '(' && close == ')');
+    }
+
+    private static @NotNull String getIndent(int level) {
+        if (level <= 0) return "";
+        return "  ".repeat(level);
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/ICarriable.java b/game/core/src/main/java/net/minecraft/core/world/ICarriable.java
index a7aefa966..d2a19fd8d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/ICarriable.java
+++ b/game/core/src/main/java/net/minecraft/core/world/ICarriable.java
@@ -25,15 +25,9 @@ public interface ICarriable {
      */
     void drop(World world, Entity holder);
 
-    /**
-     * Called before an entity tries to pick up the object
-     */
-    boolean canBeCarried(World world, Entity potentialHolder);
-
-    /**
-     * Called by an entity when attempting to pick up the object
-     */
-    ICarriable pickup(World world, Entity holder);
+    // moved to ICarriableSource
+    // boolean canBeCarried(World world, Entity potentialHolder);
+    // ICarriable pickup(World world, Entity holder, TilePosc tilePos);
 
     void writeToNBT(CompoundTag tag);
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/ICarrySource.java b/game/core/src/main/java/net/minecraft/core/world/ICarrySource.java
new file mode 100644
index 000000000..4a12e9ec3
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/ICarrySource.java
@@ -0,0 +1,25 @@
+package net.minecraft.core.world;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.world.pos.TilePosc;
+
+public interface ICarrySource {
+    @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos);
+
+    public static @Nullable ICarrySource getFromWorld(@NotNull World world, @NotNull TilePosc tilePos) {
+        if (world.getTileEntity(tilePos) instanceof ICarrySource carryTE) return carryTE;
+        if (world.getBlockType(tilePos).getLogic() instanceof ICarrySource carryTile) return carryTile;
+        return null;
+    }
+
+    public static @Nullable ICarrySource tryPickUpFromWorld(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos) {
+        final @Nullable var carry = getFromWorld(world, tilePos);
+        if (carry != null) {
+            holder.setHeldObject(carry.pickup(world, holder, tilePos));
+        }
+        return carry;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/TilePosc.java b/game/core/src/main/java/net/minecraft/core/world/pos/TilePosc.java
index 8824a90f0..5c72e0ff5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/TilePosc.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/TilePosc.java
@@ -7,9 +7,9 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.joml.Vector3d;
 import org.joml.Vector3dc;
 import org.joml.Vector3fc;
+import org.joml.Vector3i;
 import org.joml.Vector3ic;
 
 /**
@@ -22,6 +22,10 @@ public interface TilePosc {
 
     int z();
 
+    default @NotNull Vector3ic vec() {
+        return new Vector3i(x(), y(), z());
+    }
+
     int get(int component);
 
     int get(@NotNull Axis axis);
diff --git a/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java b/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
index 896e67870..17046ee13 100644
--- a/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
+++ b/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
@@ -10,8 +10,10 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.PacketBlockUpdate;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.ICarrySource;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.server.entity.player.PlayerServer;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -164,14 +166,11 @@ public class ServerPlayerController
     public boolean useOrPlaceItemStackOnTile(Player entityplayer, World world, ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         if (!entityplayer.getGamemode().canInteract()) return false;
-        int blockId = world.getBlockId(blockX, blockY, blockZ);
+        final var pos = new TilePos(blockX, blockY, blockZ);
+        int blockId = world.getBlockType(pos).id();
         if (player.getHeldObject() == null) {
-            if (player.isSneaking() && itemstack == null) { // If crouched and hand empty try to pickup block entity
-                TileEntity tileEntity = world.getTileEntity(blockX, blockY, blockZ);
-                if (tileEntity != null && tileEntity.canBeCarried(world, player)) {
-                    player.setHeldObject(tileEntity.pickup(world, player));
-                    return true;
-                }
+            if (player.isSneaking() && itemstack == null) {
+                if (ICarrySource.tryPickUpFromWorld(world, player, pos) != null) return true;
             }
             if (!player.isSneaking() || itemstack == null) {  // If standing or hand empty perform block right click method
                 if (blockId > 0 && Blocks.blocksList[blockId].onBlockRightClicked(world, blockX, blockY, blockZ, player, side, xPlaced, yPlaced)) {
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/ListTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/ListTag.java
index 0b4ffe9f0..e9854d0cf 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/ListTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/ListTag.java
@@ -108,7 +108,7 @@ public class ListTag
     @Override
     public String toString()
     {
-        if (getValue().size() > 16)
+        if (getValue().size() > 27)
         {
             return "\"" + getTagName() + "\": [ " + getValue().size() + " elements ]";
         }
